/* tslint:disable:no-use-before-declare */
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/**
 * Optional apply function.
 */
function Optional(a) {
    return (a !== undefined && a !== null) ? new SomeImpl(a) : exports.None;
}
exports.Optional = Optional;
/**
 * Class `Some[A]` represents existing values of type `A`.
 */
function Some(a) {
    return new SomeImpl(a);
}
exports.Some = Some;
//------------------------------------
//
// Implementation section.
//
//------------------------------------
var OptionalImpl = (function () {
    function OptionalImpl() {
    }
    OptionalImpl.prototype.get = function () {
        throw 'err';
    };
    /** @override */
    OptionalImpl.prototype.getOrElse = function (a) {
        return this.isEmpty ? a : this.get();
    };
    /** @override */
    OptionalImpl.prototype.map = function (f) {
        return this.isEmpty ? exports.None : Some(f(this.get()));
    };
    /** @override */
    OptionalImpl.prototype.fold = function (ifEmpty, f) {
        return this.isEmpty ? ifEmpty : f(this.get());
    };
    /** @override */
    OptionalImpl.prototype.filter = function (f) {
        return this.isEmpty || f(this.get()) ? this : exports.None;
    };
    /** @override */
    OptionalImpl.prototype.contains = function (b) {
        return this.nonEmpty && this.get() === b;
    };
    /** @override */
    OptionalImpl.prototype.exists = function (f) {
        return this.nonEmpty && f(this.get());
    };
    /** @override */
    OptionalImpl.prototype.forall = function (f) {
        return this.isEmpty || f(this.get());
    };
    /** @override */
    OptionalImpl.prototype.flatMap = function (f) {
        return this.isEmpty ? exports.None : f(this.get());
    };
    /** @override */
    OptionalImpl.prototype.foreach = function (f) {
        if (this.nonEmpty) {
            f(this.get());
        }
    };
    /** @override */
    OptionalImpl.prototype.orElse = function (ob) {
        return this.isEmpty ? ob : this;
    };
    /** @override */
    OptionalImpl.prototype.apply1 = function (ob, f) {
        return this.flatMap(function (a) { return ob.map(function (b) { return f(a, b); }); });
    };
    /** @override */
    OptionalImpl.prototype.apply2 = function (ob, oc, f) {
        return this.flatMap(function (a) { return ob.flatMap(function (b) { return oc.map(function (c) { return f(a, b, c); }); }); });
    };
    /** @override */
    OptionalImpl.prototype.apply3 = function (ob, oc, od, f) {
        return this.flatMap(function (a) { return ob.flatMap(function (b) { return oc.flatMap(function (c) { return od.map(function (d) { return f(a, b, c, d); }); }); }); });
    };
    /** @override */
    OptionalImpl.prototype.apply4 = function (ob, oc, od, oe, f) {
        return this.flatMap(function (a) { return ob.flatMap(function (b) { return oc.flatMap(function (c) { return od.flatMap(function (d) { return oe.map(function (e) { return f(a, b, c, d, e); }); }); }); }); });
    };
    /** @override */
    OptionalImpl.prototype.apply5 = function (ob, oc, od, oe, of, f) {
        return this.flatMap(function (a) { return ob.flatMap(function (b) { return oc.flatMap(function (c) { return od.flatMap(function (d) { return oe.flatMap(function (e) { return of.map(function (ff) { return f(a, b, c, d, e, ff); }); }); }); }); }); });
    };
    /** @override */
    OptionalImpl.prototype.chain = function (ob) {
        return new OptionalBuilder1(this, ob);
    };
    return OptionalImpl;
}());
var SomeImpl = (function (_super) {
    __extends(SomeImpl, _super);
    function SomeImpl(value) {
        _super.call(this);
        this.value = value;
        this.isEmpty = false;
        this.nonEmpty = true;
    }
    SomeImpl.prototype.get = function () {
        return this.value;
    };
    SomeImpl.prototype.toString = function () {
        return 'Some(' + this.value + ')';
    };
    return SomeImpl;
}(OptionalImpl));
var NoneImpl = (function (_super) {
    __extends(NoneImpl, _super);
    function NoneImpl() {
        _super.apply(this, arguments);
        this.isEmpty = true;
        this.nonEmpty = false;
    }
    NoneImpl.prototype.get = function () {
        throw new TypeError('None can not #get');
    };
    NoneImpl.prototype.toString = function () {
        return 'None';
    };
    return NoneImpl;
}(OptionalImpl));
/**
 * This object represents non-existent values.
 */
exports.None = new NoneImpl();
// Builders
var OptionalBuilder1 = (function () {
    function OptionalBuilder1(oa, ob) {
        this.oa = oa;
        this.ob = ob;
    }
    OptionalBuilder1.prototype.run = function (f) {
        return this.oa.apply1(this.ob, f);
    };
    OptionalBuilder1.prototype.chain = function (oc) {
        return new OptionalBuilder2(this.oa, this.ob, oc);
    };
    return OptionalBuilder1;
}());
exports.OptionalBuilder1 = OptionalBuilder1;
var OptionalBuilder2 = (function () {
    function OptionalBuilder2(oa, ob, oc) {
        this.oa = oa;
        this.ob = ob;
        this.oc = oc;
    }
    OptionalBuilder2.prototype.run = function (f) {
        return this.oa.apply2(this.ob, this.oc, f);
    };
    OptionalBuilder2.prototype.chain = function (od) {
        return new OptionalBuilder3(this.oa, this.ob, this.oc, od);
    };
    return OptionalBuilder2;
}());
exports.OptionalBuilder2 = OptionalBuilder2;
var OptionalBuilder3 = (function () {
    function OptionalBuilder3(oa, ob, oc, od) {
        this.oa = oa;
        this.ob = ob;
        this.oc = oc;
        this.od = od;
    }
    OptionalBuilder3.prototype.run = function (f) {
        return this.oa.apply3(this.ob, this.oc, this.od, f);
    };
    OptionalBuilder3.prototype.chain = function (oe) {
        return new OptionalBuilder4(this.oa, this.ob, this.oc, this.od, oe);
    };
    return OptionalBuilder3;
}());
exports.OptionalBuilder3 = OptionalBuilder3;
var OptionalBuilder4 = (function () {
    function OptionalBuilder4(oa, ob, oc, od, oe) {
        this.oa = oa;
        this.ob = ob;
        this.oc = oc;
        this.od = od;
        this.oe = oe;
    }
    OptionalBuilder4.prototype.run = function (f) {
        return this.oa.apply4(this.ob, this.oc, this.od, this.oe, f);
    };
    OptionalBuilder4.prototype.chain = function (of) {
        return new OptionalBuilder5(this.oa, this.ob, this.oc, this.od, this.oe, of);
    };
    return OptionalBuilder4;
}());
exports.OptionalBuilder4 = OptionalBuilder4;
var OptionalBuilder5 = (function () {
    function OptionalBuilder5(oa, ob, oc, od, oe, of) {
        this.oa = oa;
        this.ob = ob;
        this.oc = oc;
        this.od = od;
        this.oe = oe;
        this.of = of;
    }
    OptionalBuilder5.prototype.run = function (f) {
        return this.oa.apply5(this.ob, this.oc, this.od, this.oe, this.of, f);
    };
    return OptionalBuilder5;
}());
exports.OptionalBuilder5 = OptionalBuilder5;
