/** export */
import { Optional } from './Optional';
import { Either } from './Either';
import { Try } from './Try';
declare const functools: {
    Optional: <A>(a: A | null | undefined) => Optional<A>;
    Some: <A>(a: A) => Optional<A>;
    None: Optional<any>;
    Either: <A, B>(cond: boolean, left: () => A, right: () => B) => Either<A, B>;
    Left: <A, B>(a: A) => Either<A, B>;
    Right: <A, B>(b: B) => Either<A, B>;
    Try: <A>(f: () => A) => Try<A>;
    Success: <A>(a: A) => Try<A>;
    Failure: <A>(e: Error) => Try<A>;
};
export = functools;
